import requests
from bs4 import BeautifulSoup
import re
from lxml import etree


class STOF:
    def __init__(self, qtitle, keywords=[], description=""):
        self.qtitle = qtitle
        self.keywords = keywords
        self.description = description
        self.urls = []

    def searchQuestion(self):
        html_page = requests.get(
            f"https://google.com/search?q=site%3Astackoverflow.com+{self.qtitle}"
        )
        soup = BeautifulSoup(html_page.content, "html.parser")

        for link in soup.findAll("a"):
            if "https://stackoverflow.com" in link["href"]:
                self.urls.append(self.extractSOFUrl(link["href"]))
        ans = self.viewStackUrls()
        return ans

    def extractSOFUrl(self, uriString):
        uriTrimmed = uriString[7:]
        uriTrimmed = re.match(r"^.*?\&sa=", uriTrimmed).group(0)
        return uriTrimmed.replace("&sa=", "")

    def viewStackUrls(self):
        return self.viewStackOverFlowQuestion(self.urls[0])

    def viewStackOverFlowQuestion(self, url):
        html_page = requests.get(url)
        soup = BeautifulSoup(html_page.content, "html.parser")
        dom = etree.HTML(str(soup))
        answers_count = dom.xpath('//*[@id="answers-header"]/div/div[1]/h2')[
            0
        ].text.strip()
        answer = {"url": url}

        if answers_count != "":
            try:
                verified_answer = dom.xpath(
                    '//*[@class="answer accepted-answer"]/div/div[2]/div[1]'
                )[0]
                answer["content"] = etree.tostring(verified_answer).decode("utf-8")
                answer["status"] = "Verified"
                # with open("verified_answer.html", "wb") as htmlF:
                #     htmlF.write(etree.tostring(verified_answer))
                #     htmlF.close()

            except:
                try:
                    first_answer = dom.xpath('//*[@class="answer"]/div/div[2]/div[1]')[
                        0
                    ]
                    answer["content"] = etree.tostring(first_answer).decode("utf-8")
                    answer["status"] = "Most Voted"
                    # with open("first_anser.html", "wb") as htmlF:
                    #     htmlF.write(etree.tostring(first_answer))
                    #     htmlF.close()
                except:
                    answer[
                        "content"
                    ] = "Sorry the ProbExpert bot could not able find a answer from stackoverflow"
                    answer["status"] = "Null"
                    print("no answers")
                    # handle no answer
                print("no verified answer")

        # print(soup.prettify().encode("utf-8"))
        return answer

        def calculateAccuracy(self):
            """
            Compare the user's question with stackoverflow question and calculate the accuracy
            """